<?php

/*
 * Copyright (c) 1999-2005 The SquirrelMail Project Team (http://squirrelmail.org)
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 */

global $plugin_hooks;
$plugin_hooks = array();

function use_plugin ($name) {
    global $config;
    if (file_exists($config["base_path"] . "/plugins/$name/setup.php")) {
        include_once($config["base_path"] . "/plugins/$name/setup.php");
        $function = "plugin_init_$name";
        if (function_exists($function)) {
            $function();
        }
    }
}

/**
 * This function executes a hook.
 * @param string $name Name of hook to fire
 * @return mixed $data
 */
function do_hook ($name) {
    global $plugin_hooks;
    $data = func_get_args();
    $ret = '';

    if (isset($plugin_hooks[$name]) && is_array($plugin_hooks[$name])) {
        foreach ($plugin_hooks[$name] as $function) {
            if (function_exists($function)) {
                $function($data);
            }
        }
    }

    /* Variable-length argument lists have a slight problem when */
    /* passing values by reference. Pity. This is a workaround.  */
    return $data;
}

function do_hook_function($name,$parm=NULL) {
    global $plugin_hooks;
    $ret = $parm;

    if (isset($plugin_hooks[$name])
          && is_array($plugin_hooks[$name])) {
        foreach ($plugin_hooks[$name] as $function) {
            if (function_exists($function)) {
                $ret = $function($ret);
            }
        }
    }

    /* Variable-length argument lists have a slight problem when */
    /* passing values by reference. Pity. This is a workaround.  */
    return $ret;
}

/* On startup, register all plugins configured for use. */
if (isset($plugins) && is_array($plugins)) {
    foreach ($plugins as $name) {
        use_plugin($name);
    }
}

?>